## shim 0~20120906.bcd0a4e8

=== Makefile ===
ARCH		= $(shell uname -m | sed s,i[3456789]86,ia32,)

SUBDIRS		= Cryptlib

LIB_PATH	= /usr/lib64

EFI_INCLUDE	= /usr/include/efi
EFI_INCLUDES	= -nostdinc -ICryptlib -ICryptlib/Include -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol 
EFI_PATH	= /usr/lib64/gnuefi

LIB_GCC		= $(shell $(CC) -print-libgcc-file-name)
EFI_LIBS	= -lefi -lgnuefi --start-group Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a --end-group $(LIB_GCC) 

EFI_CRT_OBJS 	= $(EFI_PATH)/crt0-efi-$(ARCH).o
EFI_LDS		= $(EFI_PATH)/elf_$(ARCH)_efi.lds

CFLAGS		= -ggdb -O0 -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar \
		  -Wall -mno-red-zone \
		  $(EFI_INCLUDES)
ifeq ($(ARCH),x86_64)
	CFLAGS	+= -DEFI_FUNCTION_WRAPPER
endif
ifneq ($(origin VENDOR_CERT_FILE), undefined)
	CFLAGS += -DVENDOR_CERT_FILE=\"$(VENDOR_CERT_FILE)\"
endif

LDFLAGS		= -nostdlib -znocombreloc -T $(EFI_LDS) -shared -Bsymbolic -L$(EFI_PATH) -L$(LIB_PATH) -LCryptlib -LCryptlib/OpenSSL $(EFI_CRT_OBJS)

VERSION		= 0.1

TARGET	= shim.efi
OBJS	= shim.o cert.o
SOURCES	= shim.c shim.h signature.h PeImage.h

all: $(TARGET)

shim.o: $(SOURCES)

cert.o : cert.S
	$(CC) $(CFLAGS) -c -o $@ $<

shim.so: $(OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a cert.o
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS)

Cryptlib/libcryptlib.a:
	$(MAKE) -C Cryptlib

Cryptlib/OpenSSL/libopenssl.a:
	$(MAKE) -C Cryptlib/OpenSSL

%.efi: %.so
	objcopy -j .text -j .sdata -j .data \
		-j .dynamic -j .dynsym  -j .rel \
		-j .rela -j .reloc -j .eh_frame \
		--target=efi-app-$(ARCH) $^ $@
	objcopy -j .text -j .sdata -j .data \
		-j .dynamic -j .dynsym  -j .rel \
		-j .rela -j .reloc -j .eh_frame \
		-j .debug_info -j .debug_abbrev -j .debug_aranges \
		-j .debug_line -j .debug_str -j .debug_ranges \
		--target=efi-app-$(ARCH) $^ shim.efi.debug

clean:
	$(MAKE) -C Cryptlib clean
	$(MAKE) -C Cryptlib/OpenSSL clean
	rm -f $(TARGET) $(OBJS)

GITTAG = $(VERSION)

test-archive:
	@rm -rf /tmp/shim-$(VERSION) /tmp/shim-$(VERSION)-tmp
	@mkdir -p /tmp/shim-$(VERSION)-tmp
	@git archive --format=tar $(shell git branch | awk '/^*/ { print $$2 }') | ( cd /tmp/shim-$(VERSION)-tmp/ ; tar x )
	@git diff | ( cd /tmp/shim-$(VERSION)-tmp/ ; patch -s -p1 -b -z .gitdiff )
	@mv /tmp/shim-$(VERSION)-tmp/ /tmp/shim-$(VERSION)/
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/shim-$(VERSION).tar.bz2 shim-$(VERSION)
	@rm -rf /tmp/shim-$(VERSION)
	@echo "The archive is in shim-$(VERSION).tar.bz2"

archive:
	git tag $(GITTAG) refs/heads/master
	@rm -rf /tmp/shim-$(VERSION) /tmp/shim-$(VERSION)-tmp
	@mkdir -p /tmp/shim-$(VERSION)-tmp
	@git archive --format=tar $(GITTAG) | ( cd /tmp/shim-$(VERSION)-tmp/ ; tar x )
	@mv /tmp/shim-$(VERSION)-tmp/ /tmp/shim-$(VERSION)/
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/shim-$(VERSION).tar.bz2 shim-$(VERSION)
	@rm -rf /tmp/shim-$(VERSION)
	@echo "The archive is in shim-$(VERSION).tar.bz2"

=== Cryptlib/Makefile ===
ARCH		= $(shell uname -m | sed s,i[3456789]86,ia32,)

LIB_PATH	= /usr/lib64

EFI_INCLUDE	= /usr/include/efi
EFI_INCLUDES	= -nostdinc -IInclude -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol
EFI_PATH	= /usr/lib64/gnuefi

LIB_GCC		= $(shell $(CC) -print-libgcc-file-name)
EFI_LIBS	= -lefi -lgnuefi $(LIB_GCC)

CFLAGS		= -ggdb -O0 -I. -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar \
		  -Wall $(EFI_INCLUDES) -mno-red-zone
ifeq ($(ARCH),x86_64)
	CFLAGS	+= -DEFI_FUNCTION_WRAPPER
endif
LDFLAGS		= -nostdlib -znocombreloc

TARGET		= libcryptlib.a
OBJS		=   Hash/CryptMd4.o \
		    Hash/CryptMd5.o \
		    Hash/CryptSha1.o \
		    Hash/CryptSha256.o \
		    Hmac/CryptHmacMd5.o \
		    Hmac/CryptHmacSha1.o \
		    Cipher/CryptAes.o \
		    Cipher/CryptTdes.o \
		    Cipher/CryptArc4.o \
		    Rand/CryptRand.o \
		    Pk/CryptRsa.o \
		    Pk/CryptPkcs7.o \
		    Pk/CryptDh.o \
		    Pk/CryptX509.o \
		    Pk/CryptAuthenticode.o \
		    Pem/CryptPem.o \
		    SysCall/CrtWrapper.o \
		    SysCall/TimerWrapper.o \
		    SysCall/BaseMemAllocation.o \
		    SysCall/BaseStrings.o

all: $(TARGET)

libcryptlib.a: $(OBJS)
	ar rcs libcryptlib.a $(OBJS)
clean:
	rm -f $(TARGET) $(OBJS)

=== Cryptlib/OpenSSL/Makefile ===
ARCH		= $(shell uname -m | sed s,i[3456789]86,ia32,)

LIB_PATH	= /usr/lib64

EFI_INCLUDE	= /usr/include/efi
EFI_INCLUDES	= -I../Include -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol
EFI_PATH	= /usr/lib64/gnuefi

LIB_GCC		= $(shell $(CC) -print-libgcc-file-name)
EFI_LIBS	= -lefi -lgnuefi $(LIB_GCC)

CFLAGS		= -ggdb -O0 -I. -I.. -I../Include/ -Icrypto -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar -nostdinc \
		  -Wall $(EFI_INCLUDES) -DOPENSSL_SYSNAME_UWIN -DOPENSSL_SYS_UEFI -DL_ENDIAN -DSIXTY_FOUR_BIT_LONG -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -DOPENSSL_NO_CAMELLIA -DOPENSSL_NO_SEED -DOPENSSL_NO_RC5 -DOPENSSL_NO_MDC2 -DOPENSSL_NO_SOCK -DOPENSSL_NO_CMS -DOPENSSL_NO_JPAKE -DOPENSSL_NO_CAPIENG -DOPENSSL_NO_ERR -DOPENSSL_NO_KRB5 -DOPENSSL_NO_DYNAMIC_ENGINE -DGETPID_IS_MEANINGLESS -DOPENSSL_NO_STDIO -DOPENSSL_NO_FP_API -DOPENSSL_NO_DGRAM -DOPENSSL_NO_SHA0 -DOPENSSL_NO_SHA512 -DOPENSSL_NO_LHASH -DOPENSSL_NO_HW -DOPENSSL_NO_OCSP -DOPENSSL_NO_LOCKING -DOPENSSL_NO_DEPRECATED -DOPENSSL_SMALL_FOOTPRINT -DPEDANTIC -mno-red-zone
ifeq ($(ARCH),x86_64)
	CFLAGS	+= -DEFI_FUNCTION_WRAPPER
endif
LDFLAGS		= -nostdlib -znocombreloc

TARGET		= libopenssl.a
OBJS		=   crypto/cryptlib.o \
  crypto/dyn_lck.o \
  crypto/mem.o \
  crypto/mem_clr.o \
  crypto/mem_dbg.o \
  crypto/cversion.o \
  crypto/ex_data.o \
  crypto/cpt_err.o \
  crypto/ebcdic.o \
  crypto/uid.o \
  crypto/o_time.o \
  crypto/o_str.o \
  crypto/o_dir.o \
  crypto/o_init.o \
  crypto/fips_err.o \
  crypto/md2/md2_dgst.o \
  crypto/md2/md2_one.o \
  crypto/md4/md4_dgst.o \
  crypto/md4/md4_one.o \
  crypto/md5/md5_dgst.o \
  crypto/md5/md5_one.o \
  crypto/sha/sha_dgst.o \
  crypto/sha/sha1dgst.o \
  crypto/sha/sha_one.o \
  crypto/sha/sha1_one.o \
  crypto/sha/sha256.o \
  crypto/sha/sha512.o \
  crypto/hmac/hmac.o \
  crypto/ripemd/rmd_dgst.o \
  crypto/ripemd/rmd_one.o \
  crypto/des/des_lib.o \
  crypto/des/set_key.o \
  crypto/des/ecb_enc.o \
  crypto/des/cbc_enc.o \
  crypto/des/ecb3_enc.o \
  crypto/des/cfb64enc.o \
  crypto/des/cfb64ede.o \
  crypto/des/cfb_enc.o \
  crypto/des/ofb64ede.o \
  crypto/des/enc_read.o \
  crypto/des/enc_writ.o \
  crypto/des/ofb64enc.o \
  crypto/des/ofb_enc.o \
  crypto/des/str2key.o \
  crypto/des/pcbc_enc.o \
  crypto/des/qud_cksm.o \
  crypto/des/rand_key.o \
  crypto/des/des_enc.o \
  crypto/des/fcrypt_b.o \
  crypto/des/fcrypt.o \
  crypto/des/xcbc_enc.o \
  crypto/des/rpc_enc.o \
  crypto/des/cbc_cksm.o \
  crypto/des/ede_cbcm_enc.o \
  crypto/des/des_old.o \
  crypto/des/des_old2.o \
  crypto/des/read2pwd.o \
  crypto/rc2/rc2_ecb.o \
  crypto/rc2/rc2_skey.o \
  crypto/rc2/rc2_cbc.o \
  crypto/rc2/rc2cfb64.o \
  crypto/rc2/rc2ofb64.o \
  crypto/rc4/rc4_enc.o \
  crypto/rc4/rc4_skey.o \
  crypto/rc4/rc4_fblk.o \
  crypto/idea/i_cbc.o \
  crypto/idea/i_cfb64.o \
  crypto/idea/i_ofb64.o \
  crypto/idea/i_ecb.o \
  crypto/idea/i_skey.o \
  crypto/bf/bf_skey.o \
  crypto/bf/bf_ecb.o \
  crypto/bf/bf_enc.o \
  crypto/bf/bf_cfb64.o \
  crypto/bf/bf_ofb64.o \
  crypto/cast/c_skey.o \
  crypto/cast/c_ecb.o \
  crypto/cast/c_enc.o \
  crypto/cast/c_cfb64.o \
  crypto/cast/c_ofb64.o \
  crypto/aes/aes_misc.o \
  crypto/aes/aes_ecb.o \
  crypto/aes/aes_cfb.o \
  crypto/aes/aes_ofb.o \
  crypto/aes/aes_ctr.o \
  crypto/aes/aes_ige.o \
  crypto/aes/aes_wrap.o \
  crypto/aes/aes_core.o \
  crypto/aes/aes_cbc.o \
  crypto/bn/bn_add.o \
  crypto/bn/bn_div.o \
  crypto/bn/bn_exp.o \
  crypto/bn/bn_lib.o \
  crypto/bn/bn_ctx.o \
  crypto/bn/bn_mul.o \
  crypto/bn/bn_mod.o \
  crypto/bn/bn_print.o \
  crypto/bn/bn_rand.o \
  crypto/bn/bn_shift.o \
  crypto/bn/bn_word.o \
  crypto/bn/bn_blind.o \
  crypto/bn/bn_kron.o \
  crypto/bn/bn_sqrt.o \
  crypto/bn/bn_gcd.o \
  crypto/bn/bn_prime.o \
  crypto/bn/bn_err.o \
  crypto/bn/bn_sqr.o \
  crypto/bn/bn_asm.o \
  crypto/bn/bn_recp.o \
  crypto/bn/bn_mont.o \
  crypto/bn/bn_mpi.o \
  crypto/bn/bn_exp2.o \
  crypto/bn/bn_gf2m.o \
  crypto/bn/bn_nist.o \
  crypto/bn/bn_depr.o \
  crypto/bn/bn_x931p.o \
  crypto/bn/bn_const.o \
  crypto/bn/bn_opt.o \
  crypto/rsa/rsa_eay.o \
  crypto/rsa/rsa_gen.o \
  crypto/rsa/rsa_lib.o \
  crypto/rsa/rsa_sign.o \
  crypto/rsa/rsa_saos.o \
  crypto/rsa/rsa_err.o \
  crypto/rsa/rsa_pk1.o \
  crypto/rsa/rsa_ssl.o \
  crypto/rsa/rsa_none.o \
  crypto/rsa/rsa_oaep.o \
  crypto/rsa/rsa_chk.o \
  crypto/rsa/rsa_null.o \
  crypto/rsa/rsa_pss.o \
  crypto/rsa/rsa_x931.o \
  crypto/rsa/rsa_x931g.o \
  crypto/rsa/rsa_asn1.o \
  crypto/rsa/rsa_depr.o \
  crypto/rsa/rsa_eng.o \
  crypto/dsa/dsa_gen.o \
  crypto/dsa/dsa_key.o \
  crypto/dsa/dsa_lib.o \
  crypto/dsa/dsa_asn1.o \
  crypto/dsa/dsa_vrf.o \
  crypto/dsa/dsa_sign.o \
  crypto/dsa/dsa_err.o \
  crypto/dsa/dsa_ossl.o \
  crypto/dsa/dsa_depr.o \
  crypto/dsa/dsa_utl.o \
  crypto/dso/dso_dl.o \
  crypto/dso/dso_dlfcn.o \
  crypto/dso/dso_err.o \
  crypto/dso/dso_lib.o \
  crypto/dso/dso_null.o \
  crypto/dso/dso_openssl.o \
  crypto/dso/dso_win32.o \
  crypto/dso/dso_vms.o \
  crypto/dh/dh_asn1.o \
  crypto/dh/dh_gen.o \
  crypto/dh/dh_key.o \
  crypto/dh/dh_lib.o \
  crypto/dh/dh_check.o \
  crypto/dh/dh_err.o \
  crypto/dh/dh_depr.o \
  crypto/ec/ec_lib.o \
  crypto/ec/ecp_smpl.o \
  crypto/ec/ecp_mont.o \
  crypto/ec/ecp_nist.o \
  crypto/ec/ec_cvt.o \
  crypto/ec/ec_mult.o \
  crypto/ec/ec_err.o \
  crypto/ec/ec_curve.o \
  crypto/ec/ec_check.o \
  crypto/ec/ec_print.o \
  crypto/ec/ec_asn1.o \
  crypto/ec/ec_key.o \
  crypto/ec/ec2_smpl.o \
  crypto/ec/ec2_mult.o \
  crypto/ecdh/ech_lib.o \
  crypto/ecdh/ech_ossl.o \
  crypto/ecdh/ech_key.o \
  crypto/ecdh/ech_err.o \
  crypto/ecdsa/ecs_lib.o \
  crypto/ecdsa/ecs_asn1.o \
  crypto/ecdsa/ecs_ossl.o \
  crypto/ecdsa/ecs_sign.o \
  crypto/ecdsa/ecs_vrf.o \
  crypto/ecdsa/ecs_err.o \
  crypto/buffer/buffer.o \
  crypto/buffer/buf_str.o \
  crypto/buffer/buf_err.o \
  crypto/bio/bio_lib.o \
  crypto/bio/bio_cb.o \
  crypto/bio/bio_err.o \
  crypto/bio/bss_mem.o \
  crypto/bio/bss_null.o \
  crypto/bio/bss_fd.o \
  crypto/bio/bss_file.o \
  crypto/bio/bf_null.o \
  crypto/bio/bf_buff.o \
  crypto/bio/b_dump.o \
  crypto/bio/bf_nbio.o \
  crypto/bio/bss_log.o \
  crypto/bio/bss_bio.o \
  crypto/bio/bss_dgram.o \
  crypto/stack/stack.o \
  crypto/lhash/lhash.o \
  crypto/lhash/lh_stats.o \
  crypto/rand/md_rand.o \
  crypto/rand/randfile.o \
  crypto/rand/rand_lib.o \
  crypto/rand/rand_eng.o \
  crypto/rand/rand_err.o \
  crypto/rand/rand_egd.o \
  crypto/rand/rand_win.o \
  crypto/rand/rand_unix.o \
  crypto/rand/rand_os2.o \
  crypto/rand/rand_nw.o \
  crypto/err/err.o \
  crypto/err/err_def.o \
  crypto/err/err_all.o \
  crypto/err/err_prn.o \
  crypto/err/err_str.o \
  crypto/err/err_bio.o \
  crypto/objects/o_names.o \
  crypto/objects/obj_dat.o \
  crypto/objects/obj_lib.o \
  crypto/objects/obj_err.o \
  crypto/evp/encode.o \
  crypto/evp/digest.o \
  crypto/evp/dig_eng.o \
  crypto/evp/evp_enc.o \
  crypto/evp/evp_key.o \
  crypto/evp/evp_acnf.o \
  crypto/evp/evp_cnf.o \
  crypto/evp/e_des.o \
  crypto/evp/e_bf.o \
  crypto/evp/e_idea.o \
  crypto/evp/e_des3.o \
  crypto/evp/e_rc4.o \
  crypto/evp/e_aes.o \
  crypto/evp/names.o \
  crypto/evp/e_xcbc_d.o \
  crypto/evp/e_rc2.o \
  crypto/evp/e_cast.o \
  crypto/evp/e_rc5.o \
  crypto/evp/enc_min.o \
  crypto/evp/m_null.o \
  crypto/evp/m_md2.o \
  crypto/evp/m_md4.o \
  crypto/evp/m_md5.o \
  crypto/evp/m_sha.o \
  crypto/evp/m_sha1.o \
  crypto/evp/m_dss.o \
  crypto/evp/m_dss1.o \
  crypto/evp/m_ripemd.o \
  crypto/evp/m_ecdsa.o \
  crypto/evp/p_open.o \
  crypto/evp/p_seal.o \
  crypto/evp/p_sign.o \
  crypto/evp/p_verify.o \
  crypto/evp/p_lib.o \
  crypto/evp/p_enc.o \
  crypto/evp/p_dec.o \
  crypto/evp/bio_md.o \
  crypto/evp/bio_b64.o \
  crypto/evp/bio_enc.o \
  crypto/evp/evp_err.o \
  crypto/evp/e_null.o \
  crypto/evp/c_all.o \
  crypto/evp/c_allc.o \
  crypto/evp/c_alld.o \
  crypto/evp/evp_lib.o \
  crypto/evp/bio_ok.o \
  crypto/evp/evp_pkey.o \
  crypto/evp/evp_pbe.o \
  crypto/evp/p5_crpt.o \
  crypto/evp/p5_crpt2.o \
  crypto/evp/e_old.o \
  crypto/asn1/a_object.o \
  crypto/asn1/a_bitstr.o \
  crypto/asn1/a_utctm.o \
  crypto/asn1/a_gentm.o \
  crypto/asn1/a_time.o \
  crypto/asn1/a_int.o \
  crypto/asn1/a_octet.o \
  crypto/asn1/a_print.o \
  crypto/asn1/a_type.o \
  crypto/asn1/a_set.o \
  crypto/asn1/a_dup.o \
  crypto/asn1/a_d2i_fp.o \
  crypto/asn1/a_i2d_fp.o \
  crypto/asn1/a_enum.o \
  crypto/asn1/a_utf8.o \
  crypto/asn1/a_sign.o \
  crypto/asn1/a_digest.o \
  crypto/asn1/a_verify.o \
  crypto/asn1/a_mbstr.o \
  crypto/asn1/a_strex.o \
  crypto/asn1/x_algor.o \
  crypto/asn1/x_val.o \
  crypto/asn1/x_pubkey.o \
  crypto/asn1/x_sig.o \
  crypto/asn1/x_req.o \
  crypto/asn1/x_attrib.o \
  crypto/asn1/x_bignum.o \
  crypto/asn1/x_long.o \
  crypto/asn1/x_name.o \
  crypto/asn1/x_x509.o \
  crypto/asn1/x_x509a.o \
  crypto/asn1/x_crl.o \
  crypto/asn1/x_info.o \
  crypto/asn1/x_spki.o \
  crypto/asn1/nsseq.o \
  crypto/asn1/d2i_pu.o \
  crypto/asn1/d2i_pr.o \
  crypto/asn1/i2d_pu.o \
  crypto/asn1/i2d_pr.o \
  crypto/asn1/t_req.o \
  crypto/asn1/t_x509.o \
  crypto/asn1/t_x509a.o \
  crypto/asn1/t_crl.o \
  crypto/asn1/t_pkey.o \
  crypto/asn1/t_spki.o \
  crypto/asn1/t_bitst.o \
  crypto/asn1/tasn_new.o \
  crypto/asn1/tasn_fre.o \
  crypto/asn1/tasn_enc.o \
  crypto/asn1/tasn_dec.o \
  crypto/asn1/tasn_utl.o \
  crypto/asn1/tasn_typ.o \
  crypto/asn1/f_int.o \
  crypto/asn1/f_string.o \
  crypto/asn1/n_pkey.o \
  crypto/asn1/f_enum.o \
  crypto/asn1/a_hdr.o \
  crypto/asn1/x_pkey.o \
  crypto/asn1/a_bool.o \
  crypto/asn1/x_exten.o \
  crypto/asn1/asn_mime.o \
  crypto/asn1/asn1_gen.o \
  crypto/asn1/asn1_par.o \
  crypto/asn1/asn1_lib.o \
  crypto/asn1/asn1_err.o \
  crypto/asn1/a_meth.o \
  crypto/asn1/a_bytes.o \
  crypto/asn1/a_strnid.o \
  crypto/asn1/evp_asn1.o \
  crypto/asn1/asn_pack.o \
  crypto/asn1/p5_pbe.o \
  crypto/asn1/p5_pbev2.o \
  crypto/asn1/p8_pkey.o \
  crypto/asn1/asn_moid.o \
  crypto/pem/pem_sign.o \
  crypto/pem/pem_seal.o \
  crypto/pem/pem_info.o \
  crypto/pem/pem_lib.o \
  crypto/pem/pem_all.o \
  crypto/pem/pem_err.o \
  crypto/pem/pem_x509.o \
  crypto/pem/pem_xaux.o \
  crypto/pem/pem_oth.o \
  crypto/pem/pem_pk8.o \
  crypto/pem/pem_pkey.o \
  crypto/x509/x509_def.o \
  crypto/x509/x509_d2.o \
  crypto/x509/x509_r2x.o \
  crypto/x509/x509_cmp.o \
  crypto/x509/x509_obj.o \
  crypto/x509/x509_req.o \
  crypto/x509/x509spki.o \
  crypto/x509/x509_vfy.o \
  crypto/x509/x509_set.o \
  crypto/x509/x509cset.o \
  crypto/x509/x509rset.o \
  crypto/x509/x509_err.o \
  crypto/x509/x509name.o \
  crypto/x509/x509_v3.o \
  crypto/x509/x509_ext.o \
  crypto/x509/x509_att.o \
  crypto/x509/x509type.o \
  crypto/x509/x509_lu.o \
  crypto/x509/x_all.o \
  crypto/x509/x509_txt.o \
  crypto/x509/x509_trs.o \
  crypto/x509/by_file.o \
  crypto/x509/by_dir.o \
  crypto/x509/x509_vpm.o \
  crypto/x509v3/v3_bcons.o \
  crypto/x509v3/v3_bitst.o \
  crypto/x509v3/v3_conf.o \
  crypto/x509v3/v3_extku.o \
  crypto/x509v3/v3_ia5.o \
  crypto/x509v3/v3_lib.o \
  crypto/x509v3/v3_prn.o \
  crypto/x509v3/v3_utl.o \
  crypto/x509v3/v3err.o \
  crypto/x509v3/v3_genn.o \
  crypto/x509v3/v3_alt.o \
  crypto/x509v3/v3_skey.o \
  crypto/x509v3/v3_akey.o \
  crypto/x509v3/v3_pku.o \
  crypto/x509v3/v3_int.o \
  crypto/x509v3/v3_enum.o \
  crypto/x509v3/v3_sxnet.o \
  crypto/x509v3/v3_cpols.o \
  crypto/x509v3/v3_crld.o \
  crypto/x509v3/v3_purp.o \
  crypto/x509v3/v3_info.o \
  crypto/x509v3/v3_ocsp.o \
  crypto/x509v3/v3_akeya.o \
  crypto/x509v3/v3_pmaps.o \
  crypto/x509v3/v3_pcons.o \
  crypto/x509v3/v3_ncons.o \
  crypto/x509v3/v3_pcia.o \
  crypto/x509v3/v3_pci.o \
  crypto/x509v3/pcy_cache.o \
  crypto/x509v3/pcy_node.o \
  crypto/x509v3/pcy_data.o \
  crypto/x509v3/pcy_map.o \
  crypto/x509v3/pcy_tree.o \
  crypto/x509v3/pcy_lib.o \
  crypto/x509v3/v3_asid.o \
  crypto/x509v3/v3_addr.o \
  crypto/conf/conf_err.o \
  crypto/conf/conf_lib.o \
  crypto/conf/conf_api.o \

=== debian/changelog ===
shim (0~20120906.bcd0a4e8-0ubuntu2) quantal; urgency=low

  * debian/patches/prototypes: Include missing prototypes, and disable
    use of BIO_new_file.
  * Only build the package for amd64; we're not signing an i386 shim at this
    stage so there's no point in building it.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 04 Oct 2012 17:47:04 +0000

shim (0~20120906.bcd0a4e8-0ubuntu1) quantal; urgency=low

  * Initial release.
  * Include the Canonical Secure Boot master CA.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 04 Oct 2012 00:01:06 -0700

=== debian/control ===
Source: shim
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Steve Langasek <vorlon@debian.org>
Standards-Version: 3.9.3
Build-Depends: debhelper (>= 9), gnu-efi
Vcs-Bzr: lp:ubuntu/shim

Package: shim
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: boot loader to chain-load signed boot loaders under Secure Boot
 This package provides a minimalist boot loader which allows verifying
 signatures of other UEFI binaries against either the Secure Boot DB/DBX or
 against a built-in signature database.  Its purpose is to allow a small,
 infrequently-changing binary to be signed by the UEFI CA, while allowing
 an OS distributor to revision their main bootloader independently of the CA.

## shim 0.4

=== Makefile ===
--- 
+++ 
@@ -5,41 +5,80 @@
 LIB_PATH	= /usr/lib64
 
 EFI_INCLUDE	= /usr/include/efi
-EFI_INCLUDES	= -nostdinc -ICryptlib -ICryptlib/Include -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol 
+EFI_INCLUDES	= -nostdinc -ICryptlib -ICryptlib/Include -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol
 EFI_PATH	= /usr/lib64/gnuefi
 
 LIB_GCC		= $(shell $(CC) -print-libgcc-file-name)
 EFI_LIBS	= -lefi -lgnuefi --start-group Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a --end-group $(LIB_GCC) 
 
 EFI_CRT_OBJS 	= $(EFI_PATH)/crt0-efi-$(ARCH).o
-EFI_LDS		= $(EFI_PATH)/elf_$(ARCH)_efi.lds
+EFI_LDS		= elf_$(ARCH)_efi.lds
 
-CFLAGS		= -ggdb -O0 -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar \
-		  -Wall -mno-red-zone \
+CFLAGS		= -ggdb -O0 -fno-stack-protector -fno-strict-aliasing -fpic \
+		  -fshort-wchar -Wall -mno-red-zone -maccumulate-outgoing-args \
+		  -mno-mmx -mno-sse \
 		  $(EFI_INCLUDES)
 ifeq ($(ARCH),x86_64)
-	CFLAGS	+= -DEFI_FUNCTION_WRAPPER
+	CFLAGS	+= -DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI
 endif
 ifneq ($(origin VENDOR_CERT_FILE), undefined)
 	CFLAGS += -DVENDOR_CERT_FILE=\"$(VENDOR_CERT_FILE)\"
 endif
+ifneq ($(origin VENDOR_DBX_FILE), undefined)
+	CFLAGS += -DVENDOR_DBX_FILE=\"$(VENDOR_DBX_FILE)\"
+endif
 
 LDFLAGS		= -nostdlib -znocombreloc -T $(EFI_LDS) -shared -Bsymbolic -L$(EFI_PATH) -L$(LIB_PATH) -LCryptlib -LCryptlib/OpenSSL $(EFI_CRT_OBJS)
 
-VERSION		= 0.1
+VERSION		= 0.4
 
-TARGET	= shim.efi
-OBJS	= shim.o cert.o
-SOURCES	= shim.c shim.h signature.h PeImage.h
+TARGET	= shim.efi MokManager.efi.signed fallback.efi.signed
+OBJS	= shim.o netboot.o cert.o dbx.o
+KEYS	= shim_cert.h ocsp.* ca.* shim.crt shim.csr shim.p12 shim.pem shim.key
+SOURCES	= shim.c shim.h netboot.c signature.h PeImage.h
+MOK_OBJS = MokManager.o
+MOK_SOURCES = MokManager.c shim.h
+FALLBACK_OBJS = fallback.o
+FALLBACK_SRCS = fallback.c
 
 all: $(TARGET)
 
-shim.o: $(SOURCES)
+shim.crt:
+	./make-certs shim shim@xn--u4h.net all codesign 1.3.6.1.4.1.311.10.3.1 </dev/null
+
+shim.cer: shim.crt
+	openssl x509 -outform der -in $< -out $@
+
+shim_cert.h: shim.cer
+	echo "static UINT8 shim_cert[] = {" > $@
+	hexdump -v -e '1/1 "0x%02x, "' $< >> $@
+	echo "};" >> $@
+
+certdb/secmod.db: shim.crt
+	-mkdir certdb
+	certutil -A -n 'my CA' -d certdb/ -t CT,CT,CT -i ca.crt
+	pk12util -d certdb/ -i shim.p12 -W "" -K ""
+	certutil -d certdb/ -A -i shim.crt -n shim -t u
+
+shim.o: $(SOURCES) shim_cert.h
 
 cert.o : cert.S
 	$(CC) $(CFLAGS) -c -o $@ $<
 
-shim.so: $(OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a cert.o
+dbx.o : dbx.S
+	$(CC) $(CFLAGS) -c -o $@ $<
+
+shim.so: $(OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a
+	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS)
+
+fallback.o: $(FALLBACK_SRCS)
+
+fallback.so: $(FALLBACK_OBJS)
+	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS)
+
+MokManager.o: $(SOURCES)
+
+MokManager.so: $(MOK_OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a
 	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS)
 
 Cryptlib/libcryptlib.a:
@@ -52,18 +91,23 @@
 	objcopy -j .text -j .sdata -j .data \
 		-j .dynamic -j .dynsym  -j .rel \
 		-j .rela -j .reloc -j .eh_frame \
+		-j .vendor_cert \
 		--target=efi-app-$(ARCH) $^ $@
 	objcopy -j .text -j .sdata -j .data \
 		-j .dynamic -j .dynsym  -j .rel \
 		-j .rela -j .reloc -j .eh_frame \
 		-j .debug_info -j .debug_abbrev -j .debug_aranges \
 		-j .debug_line -j .debug_str -j .debug_ranges \
-		--target=efi-app-$(ARCH) $^ shim.efi.debug
+		--target=efi-app-$(ARCH) $^ $@.debug
+
+%.efi.signed: %.efi certdb/secmod.db
+	pesign -n certdb -i $< -c "shim" -s -o $@ -f
 
 clean:
 	$(MAKE) -C Cryptlib clean
 	$(MAKE) -C Cryptlib/OpenSSL clean
-	rm -f $(TARGET) $(OBJS)
+	rm -rf $(TARGET) $(OBJS) $(MOK_OBJS) $(FALLBACK_OBJS) $(KEYS) certdb
+	rm -f *.debug *.so *.efi
 
 GITTAG = $(VERSION)

=== Cryptlib/Makefile ===
--- 
+++ 
@@ -10,9 +10,9 @@
 EFI_LIBS	= -lefi -lgnuefi $(LIB_GCC)
 
 CFLAGS		= -ggdb -O0 -I. -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar \
-		  -Wall $(EFI_INCLUDES) -mno-red-zone
+		  -Wall $(EFI_INCLUDES) -mno-red-zone -maccumulate-outgoing-args -mno-sse -mno-mmx
 ifeq ($(ARCH),x86_64)
-	CFLAGS	+= -DEFI_FUNCTION_WRAPPER
+	CFLAGS	+= -DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI
 endif
 LDFLAGS		= -nostdlib -znocombreloc

=== Cryptlib/OpenSSL/Makefile ===
--- 
+++ 
@@ -9,10 +9,10 @@
 LIB_GCC		= $(shell $(CC) -print-libgcc-file-name)
 EFI_LIBS	= -lefi -lgnuefi $(LIB_GCC)
 
-CFLAGS		= -ggdb -O0 -I. -I.. -I../Include/ -Icrypto -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar -nostdinc \
-		  -Wall $(EFI_INCLUDES) -DOPENSSL_SYSNAME_UWIN -DOPENSSL_SYS_UEFI -DL_ENDIAN -DSIXTY_FOUR_BIT_LONG -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -DOPENSSL_NO_CAMELLIA -DOPENSSL_NO_SEED -DOPENSSL_NO_RC5 -DOPENSSL_NO_MDC2 -DOPENSSL_NO_SOCK -DOPENSSL_NO_CMS -DOPENSSL_NO_JPAKE -DOPENSSL_NO_CAPIENG -DOPENSSL_NO_ERR -DOPENSSL_NO_KRB5 -DOPENSSL_NO_DYNAMIC_ENGINE -DGETPID_IS_MEANINGLESS -DOPENSSL_NO_STDIO -DOPENSSL_NO_FP_API -DOPENSSL_NO_DGRAM -DOPENSSL_NO_SHA0 -DOPENSSL_NO_SHA512 -DOPENSSL_NO_LHASH -DOPENSSL_NO_HW -DOPENSSL_NO_OCSP -DOPENSSL_NO_LOCKING -DOPENSSL_NO_DEPRECATED -DOPENSSL_SMALL_FOOTPRINT -DPEDANTIC -mno-red-zone
+CFLAGS		= -ggdb -O0 -I. -I.. -I../Include/ -Icrypto -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar -nostdinc -mno-mmx -mno-sse -mno-red-zone -maccumulate-outgoing-args \
+		  -Wall $(EFI_INCLUDES) -DOPENSSL_SYSNAME_UWIN -DOPENSSL_SYS_UEFI -DL_ENDIAN -DSIXTY_FOUR_BIT_LONG -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -DOPENSSL_NO_CAMELLIA -DOPENSSL_NO_SEED -DOPENSSL_NO_RC5 -DOPENSSL_NO_MDC2 -DOPENSSL_NO_SOCK -DOPENSSL_NO_CMS -DOPENSSL_NO_JPAKE -DOPENSSL_NO_CAPIENG -DOPENSSL_NO_ERR -DOPENSSL_NO_KRB5 -DOPENSSL_NO_DYNAMIC_ENGINE -DGETPID_IS_MEANINGLESS -DOPENSSL_NO_STDIO -DOPENSSL_NO_FP_API -DOPENSSL_NO_DGRAM -DOPENSSL_NO_SHA0 -DOPENSSL_NO_SHA512 -DOPENSSL_NO_LHASH -DOPENSSL_NO_HW -DOPENSSL_NO_OCSP -DOPENSSL_NO_LOCKING -DOPENSSL_NO_DEPRECATED -DOPENSSL_SMALL_FOOTPRINT -DPEDANTIC
 ifeq ($(ARCH),x86_64)
-	CFLAGS	+= -DEFI_FUNCTION_WRAPPER
+	CFLAGS	+= -DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI
 endif
 LDFLAGS		= -nostdlib -znocombreloc
 
@@ -439,5 +439,3 @@
   crypto/x509v3/v3_asid.o \
   crypto/x509v3/v3_addr.o \
   crypto/conf/conf_err.o \
-  crypto/conf/conf_lib.o \
-  crypto/conf/conf_api.o \

=== debian/changelog ===
shim (0.4-0ubuntu4) saucy; urgency=low

  * debian/patches/fix-tftp-prototype: pass the right arguments to
    EFI_PXE_BASE_CODE_TFTP_READ_FILE.
  * debian/patches/build-with-Werror: Build with -Werror to catch future
    prototype mismatches.
  * debian/patches/fix-compiler-warnings: Fix remaining compiler
    warnings in netboot.c.
  * debian/patches/tftp-proper-nul-termination: fix nul termination
    errors in filenames passed to tftp.
  * debian/patches/netboot-cleanup: roll-up of miscellaneous fixes to
    the netboot code.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 23 Sep 2013 00:30:00 -0700

shim (0.4-0ubuntu3) saucy; urgency=low

  [ Steve Langasek ]
  * Install MokManager.efi.signed in the package.
  * debian/patches/no-output-by-default.patch: Don't print any
    informational messages.  Closes LP: #1074302.

  [ Stéphane Graber ]
  * debian/patches/no-print-on-unsigned: Don't print an error message when
    validating an unsigned binary as that tends to hang Lenovo machines.
    (LP: #1087501)

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 08 Aug 2013 17:12:12 +0200

shim (0.4-0ubuntu2) saucy; urgency=low

  * Add missing build-dependency on openssl.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 02 Jul 2013 20:30:43 +0000

shim (0.4-0ubuntu1) saucy; urgency=low

  * New upstream release.
  * Drop debian/patches/shim-before-loadimage; upstream has changed this to
    not call loadimage at all.
  * debian/patches/sbsigntool-not-pesign: Sign MokManager with
    sbsigntool instead of pesign.
  * Add a versioned build-dependency on gnu-efi.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 02 Jul 2013 12:53:24 -0700

shim (0~20120906.bcd0a4e8-0ubuntu4) quantal-proposed; urgency=low

  * debian/patches/shim-before-loadimage: Use direct verification first
    before LoadImage.  Addresses an issue where Lenovo's SecureBoot
    implementation pops an error message on any verification failure - avoid
    calling LoadImage at all unless we have to.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 10 Oct 2012 15:28:40 -0700

shim (0~20120906.bcd0a4e8-0ubuntu3) quantal; urgency=low

  * debian/patches/second-stage-path: Chainload grubx64.efi, not
    grub.efi.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 05 Oct 2012 11:20:58 -0700

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Steve Langasek <vorlon@debian.org>
 Standards-Version: 3.9.3
-Build-Depends: debhelper (>= 9), gnu-efi
+Build-Depends: debhelper (>= 9), gnu-efi (>= 3.0u), sbsigntool, openssl
 Vcs-Bzr: lp:ubuntu/shim
 
 Package: shim

## shim 0.7

=== debian/changelog ===
shim (0.7-0ubuntu4) utopic; urgency=medium

  * SECURITY UPDATE: heap overflow and out-of-bounds read access when
    parsing DHCPv6 information
    - debian/patches/CVE-2014-3675.patch: apply proper bounds checking
      when parsing data provided in DHCPv6 packets.
    - CVE-2014-3675
    - CVE-2014-3676
  * SECURITY UPDATE: memory corruption when processing user-provided key
    lists
    - debian/patches/CVE-2014-3677.patch: detect malformed machine owner
      key (MOK) lists and ignore them, avoiding possible memory corruption.
    - CVE-2014-3677

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 08 Oct 2014 06:40:40 +0000

shim (0.7-0ubuntu2) utopic; urgency=medium

  * Restore debian/patches/prototypes, which still is needed on shim 0.7
    but only detected on the buildds.
  * Update debian/patches/prototypes with some new declarations needed for
    openssl 0.9.8za update.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Oct 2014 16:20:08 -0700

shim (0.7-0ubuntu1) utopic; urgency=medium

  * New upstream release.
    - fix spurious error message when fallback.efi is not present, as will
      always be the case for removable media.  LP: #1297069.
    - drop most patches, included upstream.
  * debian/patches/0001-Update-openssl-to-0.9.8za.patch: cherry-pick
    openssl 0.9.8za in via upstream.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Oct 2014 05:40:41 +0000

shim (0.4-0ubuntu5) utopic; urgency=low

  * Install fallback.efi.signed as well, to lay the groundwork for fallback
    handling (wanted when we have to move a drive between machines, or when
    the firmware loses its marbles^W nvram).

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Aug 2014 12:11:13 +0200

## shim 0.8

=== Makefile ===
CC		= $(CROSS_COMPILE)gcc
LD		= $(CROSS_COMPILE)ld
OBJCOPY		= $(CROSS_COMPILE)objcopy

ARCH		= $(shell $(CC) -dumpmachine | cut -f1 -d- | sed s,i[3456789]86,ia32,)

SUBDIRS		= Cryptlib lib

LIB_PATH	= /usr/lib64

EFI_INCLUDE	:= /usr/include/efi
EFI_INCLUDES	= -nostdinc -ICryptlib -ICryptlib/Include -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol -Iinclude
EFI_PATH	:= /usr/lib64/gnuefi

LIB_GCC		= $(shell $(CC) -print-libgcc-file-name)
EFI_LIBS	= -lefi -lgnuefi --start-group Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a --end-group $(LIB_GCC) 

EFI_CRT_OBJS 	= $(EFI_PATH)/crt0-efi-$(ARCH).o
EFI_LDS		= elf_$(ARCH)_efi.lds

DEFAULT_LOADER	:= \\\\grub.efi
CFLAGS		= -ggdb -O0 -fno-stack-protector -fno-strict-aliasing -fpic \
		  -fshort-wchar -Wall -Wsign-compare -Werror -fno-builtin \
		  -Werror=sign-compare \
		  "-DDEFAULT_LOADER=L\"$(DEFAULT_LOADER)\"" \
		  "-DDEFAULT_LOADER_CHAR=\"$(DEFAULT_LOADER)\"" \
		  $(EFI_INCLUDES)

ifneq ($(origin OVERRIDE_SECURITY_POLICY), undefined)
	CFLAGS	+= -DOVERRIDE_SECURITY_POLICY
endif

ifeq ($(ARCH),x86_64)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc -maccumulate-outgoing-args \
		-DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI
endif
ifeq ($(ARCH),ia32)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc -maccumulate-outgoing-args -m32
endif

ifeq ($(ARCH),aarch64)
	CFLAGS	+= -ffreestanding -I$(shell $(CC) -print-file-name=include)
endif

ifeq ($(ARCH),arm)
	CFLAGS	+= -ffreestanding -I$(shell $(CC) -print-file-name=include)
endif

ifneq ($(origin VENDOR_CERT_FILE), undefined)
	CFLAGS += -DVENDOR_CERT_FILE=\"$(VENDOR_CERT_FILE)\"
endif
ifneq ($(origin VENDOR_DBX_FILE), undefined)
	CFLAGS += -DVENDOR_DBX_FILE=\"$(VENDOR_DBX_FILE)\"
endif

LDFLAGS		= -nostdlib -znocombreloc -T $(EFI_LDS) -shared -Bsymbolic -L$(EFI_PATH) -L$(LIB_PATH) -LCryptlib -LCryptlib/OpenSSL $(EFI_CRT_OBJS)

VERSION		= 0.8

TARGET	= shim.efi MokManager.efi.signed fallback.efi.signed
OBJS	= shim.o netboot.o cert.o replacements.o version.o
KEYS	= shim_cert.h ocsp.* ca.* shim.crt shim.csr shim.p12 shim.pem shim.key shim.cer
SOURCES	= shim.c shim.h netboot.c include/PeImage.h include/wincert.h include/console.h replacements.c replacements.h version.c version.h
MOK_OBJS = MokManager.o PasswordCrypt.o crypt_blowfish.o
MOK_SOURCES = MokManager.c shim.h include/console.h PasswordCrypt.c PasswordCrypt.h crypt_blowfish.c crypt_blowfish.h
FALLBACK_OBJS = fallback.o
FALLBACK_SRCS = fallback.c

all: $(TARGET)

shim.crt:
	./make-certs shim shim@xn--u4h.net all codesign 1.3.6.1.4.1.311.10.3.1 </dev/null

shim.cer: shim.crt
	openssl x509 -outform der -in $< -out $@

shim_cert.h: shim.cer
	echo "static UINT8 shim_cert[] = {" > $@
	hexdump -v -e '1/1 "0x%02x, "' $< >> $@
	echo "};" >> $@

version.c : version.c.in
	sed	-e "s,@@VERSION@@,$(VERSION)," \
		-e "s,@@UNAME@@,$(shell uname -a)," \
		-e "s,@@COMMIT@@,$(shell if [ -d .git ] ; then git log -1 --pretty=format:%H ; elif [ -f commit ]; then cat commit ; else echo commit id not available; fi)," \
		< version.c.in > version.c

certdb/secmod.db: shim.crt
	-mkdir certdb
	pk12util -d certdb/ -i shim.p12 -W "" -K ""
	certutil -d certdb/ -A -i shim.crt -n shim -t u

shim.o: $(SOURCES) shim_cert.h

cert.o : cert.S
	$(CC) $(CFLAGS) -c -o $@ $<

shim.so: $(OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a lib/lib.a
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS)

fallback.o: $(FALLBACK_SRCS)

fallback.so: $(FALLBACK_OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a lib/lib.a
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS)

MokManager.o: $(MOK_SOURCES)

MokManager.so: $(MOK_OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a lib/lib.a
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS) lib/lib.a

Cryptlib/libcryptlib.a:
	$(MAKE) -C Cryptlib

Cryptlib/OpenSSL/libopenssl.a:
	$(MAKE) -C Cryptlib/OpenSSL

lib/lib.a:
	$(MAKE) -C lib

ifeq ($(ARCH),aarch64)
FORMAT		:= -O binary
SUBSYSTEM	:= 0xa
LDFLAGS		+= --defsym=EFI_SUBSYSTEM=$(SUBSYSTEM)
endif

ifeq ($(ARCH),arm)
FORMAT		:= -O binary
SUBSYSTEM	:= 0xa
LDFLAGS		+= --defsym=EFI_SUBSYSTEM=$(SUBSYSTEM)
endif

FORMAT		?= --target efi-app-$(ARCH)

%.efi: %.so
	$(OBJCOPY) -j .text -j .sdata -j .data \
		-j .dynamic -j .dynsym  -j .rel* \
		-j .rela* -j .reloc -j .eh_frame \
		-j .vendor_cert \
		$(FORMAT)  $^ $@
	$(OBJCOPY) -j .text -j .sdata -j .data \
		-j .dynamic -j .dynsym  -j .rel* \
		-j .rela* -j .reloc -j .eh_frame \
		-j .debug_info -j .debug_abbrev -j .debug_aranges \
		-j .debug_line -j .debug_str -j .debug_ranges \
		$(FORMAT) $^ $@.debug

%.efi.signed: %.efi certdb/secmod.db
	pesign -n certdb -i $< -c "shim" -s -o $@ -f

clean:
	$(MAKE) -C Cryptlib clean
	$(MAKE) -C Cryptlib/OpenSSL clean
	$(MAKE) -C lib clean
	rm -rf $(TARGET) $(OBJS) $(MOK_OBJS) $(FALLBACK_OBJS) $(KEYS) certdb
	rm -f *.debug *.so *.efi *.tar.* version.c

GITTAG = $(VERSION)

test-archive:
	@rm -rf /tmp/shim-$(VERSION) /tmp/shim-$(VERSION)-tmp
	@mkdir -p /tmp/shim-$(VERSION)-tmp
	@git archive --format=tar $(shell git branch | awk '/^*/ { print $$2 }') | ( cd /tmp/shim-$(VERSION)-tmp/ ; tar x )
	@git diff | ( cd /tmp/shim-$(VERSION)-tmp/ ; patch -s -p1 -b -z .gitdiff )
	@mv /tmp/shim-$(VERSION)-tmp/ /tmp/shim-$(VERSION)/
	@git log -1 --pretty=format:%H > /tmp/shim-$(VERSION)/commit
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/shim-$(VERSION).tar.bz2 shim-$(VERSION)
	@rm -rf /tmp/shim-$(VERSION)
	@echo "The archive is in shim-$(VERSION).tar.bz2"

tag:
	git tag --sign $(GITTAG) refs/heads/master

archive: tag
	@rm -rf /tmp/shim-$(VERSION) /tmp/shim-$(VERSION)-tmp
	@mkdir -p /tmp/shim-$(VERSION)-tmp
	@git archive --format=tar $(GITTAG) | ( cd /tmp/shim-$(VERSION)-tmp/ ; tar x )
	@mv /tmp/shim-$(VERSION)-tmp/ /tmp/shim-$(VERSION)/
	@git log -1 --pretty=format:%H > /tmp/shim-$(VERSION)/commit
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/shim-$(VERSION).tar.bz2 shim-$(VERSION)
	@rm -rf /tmp/shim-$(VERSION)
	@echo "The archive is in shim-$(VERSION).tar.bz2"

export ARCH CC LD OBJCOPY EFI_INCLUDE

=== Cryptlib/Makefile ===

EFI_INCLUDES	= -IInclude -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol

CFLAGS		= -ggdb -O0 -I. -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar \
		  -Wall $(EFI_INCLUDES)

ifeq ($(ARCH),x86_64)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc -maccumulate-outgoing-args \
		-DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI
endif
ifeq ($(ARCH),ia32)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc -maccumulate-outgoing-args -m32
endif
LDFLAGS		= -nostdlib -znocombreloc

TARGET		= libcryptlib.a
OBJS		=   Hash/CryptMd4.o \
		    Hash/CryptMd5.o \
		    Hash/CryptSha1.o \
		    Hash/CryptSha256.o \
		    Hmac/CryptHmacMd5.o \
		    Hmac/CryptHmacSha1.o \
		    Cipher/CryptAes.o \
		    Cipher/CryptTdes.o \
		    Cipher/CryptArc4.o \
		    Rand/CryptRand.o \
		    Pk/CryptRsaBasic.o \
		    Pk/CryptRsaExtNull.o \
		    Pk/CryptPkcs7SignNull.o \
		    Pk/CryptPkcs7Verify.o \
		    Pk/CryptDhNull.o \
		    Pk/CryptX509.o \
		    Pk/CryptAuthenticode.o \
		    Pem/CryptPem.o \
		    SysCall/CrtWrapper.o \
		    SysCall/TimerWrapper.o \
		    SysCall/BaseMemAllocation.o \
		    SysCall/BaseStrings.o

all: $(TARGET)

libcryptlib.a: $(OBJS)
	ar rcs libcryptlib.a $(OBJS)
clean:
	rm -f $(TARGET) $(OBJS)

=== lib/Makefile ===
TARGET = lib.a

LIBFILES = simple_file.o guid.o console.o execute.o configtable.o shell.o variables.o security_policy.o

EFI_INCLUDES    = -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol -I../include

CFLAGS          = -ggdb -O0 -fno-stack-protector -fno-strict-aliasing -fpic \
		  -fshort-wchar -Wall -DBUILD_EFI -fno-builtin -Werror \
		  $(EFI_INCLUDES)

ifeq ($(ARCH),x86_64)
        CFLAGS  += -mno-red-zone -DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI
endif
ifeq ($(ARCH),ia32)
        CFLAGS  += -mno-red-zone -m32
endif

lib.a: $(LIBFILES)
	ar rcs lib.a $(LIBFILES)

all: $(TARGET)

clean:
	rm -f lib.a
	rm -f $(LIBFILES)

=== Cryptlib/OpenSSL/Makefile ===
--- 
+++ 
@@ -1,18 +1,22 @@
-ARCH		= $(shell uname -m | sed s,i[3456789]86,ia32,)
 
-LIB_PATH	= /usr/lib64
+EFI_INCLUDES	= -I../Include -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol
 
-EFI_INCLUDE	= /usr/include/efi
-EFI_INCLUDES	= -I../Include -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol
-EFI_PATH	= /usr/lib64/gnuefi
+CFLAGS		= -ggdb -O0 -I. -I.. -I../Include/ -Icrypto -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar -nostdinc \
+		  -Wall $(EFI_INCLUDES) -DOPENSSL_SYSNAME_UWIN -DOPENSSL_SYS_UEFI -DL_ENDIAN -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -DOPENSSL_NO_CAMELLIA -DOPENSSL_NO_SEED -DOPENSSL_NO_RC5 -DOPENSSL_NO_MDC2 -DOPENSSL_NO_SOCK -DOPENSSL_NO_CMS -DOPENSSL_NO_JPAKE -DOPENSSL_NO_CAPIENG -DOPENSSL_NO_ERR -DOPENSSL_NO_KRB5 -DOPENSSL_NO_DYNAMIC_ENGINE -DGETPID_IS_MEANINGLESS -DOPENSSL_NO_STDIO -DOPENSSL_NO_FP_API -DOPENSSL_NO_DGRAM -DOPENSSL_NO_SHA0 -DOPENSSL_NO_LHASH -DOPENSSL_NO_HW -DOPENSSL_NO_OCSP -DOPENSSL_NO_LOCKING -DOPENSSL_NO_DEPRECATED -DOPENSSL_SMALL_FOOTPRINT -DPEDANTIC
 
-LIB_GCC		= $(shell $(CC) -print-libgcc-file-name)
-EFI_LIBS	= -lefi -lgnuefi $(LIB_GCC)
-
-CFLAGS		= -ggdb -O0 -I. -I.. -I../Include/ -Icrypto -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar -nostdinc -mno-mmx -mno-sse -mno-red-zone -maccumulate-outgoing-args \
-		  -Wall $(EFI_INCLUDES) -DOPENSSL_SYSNAME_UWIN -DOPENSSL_SYS_UEFI -DL_ENDIAN -DSIXTY_FOUR_BIT_LONG -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -DOPENSSL_NO_CAMELLIA -DOPENSSL_NO_SEED -DOPENSSL_NO_RC5 -DOPENSSL_NO_MDC2 -DOPENSSL_NO_SOCK -DOPENSSL_NO_CMS -DOPENSSL_NO_JPAKE -DOPENSSL_NO_CAPIENG -DOPENSSL_NO_ERR -DOPENSSL_NO_KRB5 -DOPENSSL_NO_DYNAMIC_ENGINE -DGETPID_IS_MEANINGLESS -DOPENSSL_NO_STDIO -DOPENSSL_NO_FP_API -DOPENSSL_NO_DGRAM -DOPENSSL_NO_SHA0 -DOPENSSL_NO_SHA512 -DOPENSSL_NO_LHASH -DOPENSSL_NO_HW -DOPENSSL_NO_OCSP -DOPENSSL_NO_LOCKING -DOPENSSL_NO_DEPRECATED -DOPENSSL_SMALL_FOOTPRINT -DPEDANTIC
 ifeq ($(ARCH),x86_64)
-	CFLAGS	+= -DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI
+	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -maccumulate-outgoing-args \
+		-DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI -DSIXTY_FOUR_BIT_LONG
+endif
+ifeq ($(ARCH),ia32)
+	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -maccumulate-outgoing-args \
+		-m32 -DTHIRTY_TWO_BIT
+endif
+ifeq ($(ARCH),aarch64)
+	CFLAGS	+= -O2 -DSIXTY_FOUR_BIT_LONG -ffreestanding -I$(shell $(CC) -print-file-name=include)
+endif
+ifeq ($(ARCH),arm)
+	CFLAGS	+= -O2 -DTHIRTY_TWO_BIT -ffreestanding -I$(shell $(CC) -print-file-name=include)
 endif
 LDFLAGS		= -nostdlib -znocombreloc
 
@@ -215,6 +219,7 @@
   crypto/bio/bf_null.o \
   crypto/bio/bf_buff.o \
   crypto/bio/b_dump.o \
+  crypto/bio/b_print.o \
   crypto/bio/bf_nbio.o \
   crypto/bio/bss_log.o \
   crypto/bio/bss_bio.o \
@@ -434,8 +439,3 @@
   crypto/x509v3/pcy_node.o \
   crypto/x509v3/pcy_data.o \
   crypto/x509v3/pcy_map.o \
-  crypto/x509v3/pcy_tree.o \
-  crypto/x509v3/pcy_lib.o \
-  crypto/x509v3/v3_asid.o \
-  crypto/x509v3/v3_addr.o \
-  crypto/conf/conf_err.o \

=== debian/changelog ===
shim (0.8-0ubuntu2) wily; urgency=medium

  * No-change rebuild against gnu-efi 3.0v-5ubuntu1.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 May 2015 17:48:30 +0000

shim (0.8-0ubuntu1) wily; urgency=medium

  * New upstream release.
    - Clarify meaning of insecure_mode. (LP: #1384973)
  * debian/patches/CVE-2014-3675.patch, debian/patches/CVE-2014-3677.patch,
    debian/patches/0001-Update-openssl-to-0.9.8za.patch: dropped, included
    in the upstream release.
  * debian/patches/sbsigntool-not-pesign,debian/patches/second-stage-path:
    refreshed.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 11 May 2015 19:50:49 -0400

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- EFI_PATH=/usr/lib VENDOR_CERT_FILE=debian/canonical-uefi-ca.der

## shim 0.9+1465500757.14a5905.is.0.8

=== debian/changelog ===
shim (0.9+1465500757.14a5905.is.0.8-0ubuntu3) vivid; urgency=medium

  * Ship a prebuilt MokManager.efi.signed from debian/, since for the revert
    files need to match a one-time signing key, and shim-signed ships shim 0.8
    with a specific key we can't reproduce here.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 06 Oct 2016 16:59:26 -0400

shim (0.9+1465500757.14a5905.is.0.8-0ubuntu2) wily; urgency=medium

  * Revert to shim 0.8 for now; which at least doesn't crash if fallback.efi
    is absent. (LP: #1624096)
    - This effectively reverts shim to 0.8-0ubuntu2.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 03 Oct 2016 14:32:28 -0400

shim (0.9+1465500757.14a5905-0ubuntu1) yakkety; urgency=medium

  * New upstream release.
    - Better handle LoadOptions. (LP: #1581299)
    - Measure state and second stage in TPM.
    - Mirror MokSBState in runtime as MokSBStateRT.
    - Fix failure to build with GCC 5. (LP: #1429978)
    - Various bug fixes and other improvements.
  * Refreshed patches.
    - Remaining patches:
      + second-stage-path
      + sbsigntool-not-pesign 
  * debian/patches/unused-variable: remove unused variable size.
  * debian/patches/binutils-version-matching: revert d9a4c912 to correctly
    match objcopy's version on Ubuntu.
  * debian/copyright: update copyright for patches.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 26 Jul 2016 16:48:32 -0400
